# -*- coding:utf-8 -*-
# pyScreenShot v1.00
# 2006(c) uglydog (http://nanabit.net/)
#
import os, sys, string, getopt, datetime
import Image, ImageFile, ImageGrab, PngImagePlugin # require PIL(http://www.pythonware.com/products/pil/index.htm)
VERSION = '1.00'

#
# show_usage()
#
#
def show_usage():
	print 'pyScreenShot v'+VERSION
	print 'スクリーンショットを取って保存'
	print 'usage:'
	print ' -h, --help :ヘルプ'
	print ' -d, --dst-directory= :出力先ディレクトリ(省略時はカレントディレクトリ)'
	print ' -f, --base-filename= :基本ファイル名(この後に日付が付きます;省略時は"ss")'
	print ' -s, --show :撮影後開く'

def main():
	try:
		options, args = getopt.gnu_getopt(sys.argv[1:], 'hd:f:', \
			['help', 'dst-directory=', 'base-filename='])
	except:
		print 'wrong arguments'
		show_usage()
		sys.exit(1)

	# -h, --help :ヘルプ
	for option, argument in options:
		if option=='-h' or option=='--help':
			show_usage()
			sys.exit(0)

	#その他の引数
	show = 0
	dst_directory = os.getcwd()
	base_filename = 'ss'
	for option, argument in options:
		# -s, --show :撮影後開く
		if option=='-s' or option=='--show':
			show = 1
		
		# -d, --dst-directory= :出力先ディレクトリ(省略時はカレントディレクトリ)
		if option=='-d' or option=='--dst-directory':
			dst_directory = argument
		
		# -f, --base-filename= :基本ファイル名(この後に日付が付きます;省略時は"ss")'
		if option=='-f' or option=='--base-filename':
			base_filename = argument
	
	im = ImageGrab.grab()
	
	if isinstance(im, Image.Image):
		timestamp = datetime.datetime.now().strftime('-%Y%m%d-%H%M%S')
		# 重複しない名前を付ける
		original_filebody = os.path.join(dst_directory, base_filename+timestamp)
		add_n = 0
		filename = original_filebody+'.png'
		while os.path.isfile(filename):
			add_n += 1
			filename = original_filebody+('(%d).png' % add_n)
		
		im.save(filename)
		if show:
			im.show()
	else:
		print 'failed'
		sys.exit(1)
	
if __name__ == '__main__':
	main()